import com.nttdocomo.ui.Font;
import com.nttdocomo.ui.Graphics;
import com.nttdocomo.ui.Image;

public class Disp480x640 implements Disp{
	private final GBCanvas gui;
	private final GBCore core;
	private Image img = null;
	private Image BaseImg = null;
	private Image BaseImg2 = null;
	private Image StrImg = null;
	private Graphics imgG = null;
	private Graphics BaseImgG = null;
	private Graphics BaseImg2G = null;
	private Graphics StrImgG = null;
	private int w;
	private int h;

	private final int HEIGHT_LINE;
	private final int BASE_LINE;

	{
		HEIGHT_LINE = Font.getDefaultFont().getHeight() + (1 + 2 * 2) * 2;
		BASE_LINE = 6 + Font.getDefaultFont().getAscent();
	}

	Disp480x640(GBCanvas _gui, GBCore _core){
		gui = _gui;
		core = _core;
		img = gui.fb2;

		BaseImg = Image.createImage(gui.getHeight(), gui.getWidth());
		BaseImgG = BaseImg.getGraphics();
		BaseImg2 = Image.createImage(gui.getWidth(), gui.getHeight());
		BaseImg2G = BaseImg2.getGraphics();

		StrImg = Image.createImage(gui.getHeight(), 32);
		StrImgG = StrImg.getGraphics();
		StrImgG.setFont(Font.getDefaultFont());

	}

	public void init(){
		w = gui.width;
		h = gui.height;
	}

	public void vrt(Graphics g, String messageStr, int fpsDisp){
		g.setFlipMode(Graphics.FLIP_NONE);
		// w  h ͉Ȃ̂ŋtɂȂB킩ɂEEE
		g.drawScaledImage(img, (h - 320) / 2, (w - 320) / 2, 320, 288, 0, 0, 160, 144);
		switch (fpsDisp) {
			case 0 :
			case 1 :
				//  - ŉ[X^bN
				//  - ŉ[tB
				// 	\ʒu͊gƓقHƂ肠bŃQ[ʂ̂
				if (messageStr != null) {
					g.setColor(Graphics.getColorOfName(Graphics.BLACK));
					g.fillRect(0, (w - 320) / 2 + 288, h, 32);
					g.setColor(Graphics.getColorOfName(Graphics.WHITE));
					g.drawString(messageStr, (h - 320) / 2 + 8, (w - 320) / 2 + 288 + BASE_LINE);
					messageStr = null;
				}
				break;
			case 2 :
				//  - E[TCh
				if (messageStr != null) {
					StrImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					StrImgG.fillRect(0, 0, w, 32);
					StrImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					StrImgG.drawString(messageStr, w / 2 - 120, BASE_LINE);
					g.setFlipMode(Graphics.FLIP_ROTATE_LEFT);
					g.drawImage(StrImg, (h - 320) / 2 + 320, 0, 0, 0, w, 32);
					messageStr = null;
				}
				break;
			default :
				break;

		}
	}

	public void vrt_large(Graphics g, String messageStr, int fpsDisp, boolean Anti_Alias){
		g.setFlipMode(Graphics.FLIP_NONE);
		// w  h ͉Ȃ̂ŋtɂȂB킩ɂEEE
		switch (fpsDisp) {
			case 0 :
			case 1 :
				if (Anti_Alias) {
					g.drawScaledImage(img, 0, (w - 464) / 2, 480, 432, 0, 0, 240, 216);
				} else {
					g.drawScaledImage(img, 0, (w - 464) / 2, 480, 432, 0, 0, 160, 144);
				}
				//ʃTCYIɃX^bNKvȂ̂ŁA
				//  - ŉ[X^bN
				//  - ŉ[tB
				if (messageStr != null) {
					g.setColor(Graphics.getColorOfName(Graphics.BLACK));
					g.fillRect(0, (w - 464) / 2 + 432, h, 32);
					g.setColor(Graphics.getColorOfName(Graphics.WHITE));
					g.drawString(messageStr, 8, (w - 464) / 2 + 432 + BASE_LINE);
					messageStr = null;
				}
				break;
			case 2 :
				if (Anti_Alias) {
					g.drawScaledImage(img, 0, (w - 432) / 2, 448, 432, 0, 0, 240, 216);
				} else {
					g.drawScaledImage(img, 0, (w - 432) / 2, 448, 432, 0, 0, 160, 144);
				}
				//  - E[TCh
				if (messageStr != null) {
					StrImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					StrImgG.fillRect(0, 0, w, 32);
					StrImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					StrImgG.drawString(messageStr, w / 2 - 208, BASE_LINE);
					g.setFlipMode(Graphics.FLIP_ROTATE_LEFT);
					g.drawImage(StrImg, h - 32, 0, 0, 0, w, 32);
					messageStr = null;
				}
				break;
			default :
				if (Anti_Alias) {
					g.drawScaledImage(img, 0, (w - 464) / 2, 480, 432, 0, 0, 240, 216);
				} else {
					g.drawScaledImage(img, 0, (w - 464) / 2, 480, 432, 0, 0, 160, 144);
				}
				break;
		}
	}

	public void vrt_wide(Graphics g, String messageStr, int fpsDisp, boolean Anti_Alias){
		g.setFlipMode(Graphics.FLIP_NONE);
		switch (fpsDisp) {
			case 0 :
				BaseImg2G.setColor(Graphics.getColorOfName(Graphics.BLACK));
				BaseImg2G.fillRect(0, 0, h, w);
				BaseImg2G.setFlipMode(Graphics.FLIP_NONE);
				if (Anti_Alias) {
					BaseImg2G.drawScaledImage(img, 0, (w - 640) / 2, 480, 640, 0, 0, 240, 216);
				} else {
					BaseImg2G.drawScaledImage(img, 0, (w - 640) / 2, 480, 640, 0, 0, 160, 144);
				}
				//  - ŉ[X^bN
				if (messageStr != null) {
					BaseImg2G.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00, 0xAA));
					BaseImg2G.fillRect(0, (w - 640) / 2 + 608, h, 32);
					BaseImg2G.setColor(Graphics.getColorOfName(Graphics.WHITE));
					BaseImg2G.drawString(messageStr, 8, (w - 640) / 2 + 608 + BASE_LINE);
					messageStr = null;
				}
				g.drawImage(BaseImg2, 0, 0);
				break;
			case 1 :
				if (Anti_Alias) {
					g.drawScaledImage(img, 0, (w - 640) / 2, 480, 608, 0, 0, 240, 216);
				} else {
					g.drawScaledImage(img, 0, (w - 640) / 2, 480, 608, 0, 0, 160, 144);
				}
				//  - ŉ[tB
				if (messageStr != null) {
					g.setColor(Graphics.getColorOfName(Graphics.BLACK));
					g.fillRect(0, (w - 640) / 2 + 608, h, 32);
					g.setColor(Graphics.getColorOfName(Graphics.WHITE));
					g.drawString(messageStr, 8, (w - 640) / 2 + 608 + BASE_LINE);
					messageStr = null;
				}
				break;
			case 2 :
				if (Anti_Alias) {
					g.drawScaledImage(img, 0, (w - 640) / 2, 448 , 640, 0, 0, 240, 216);
				} else {
					g.drawScaledImage(img, 0, (w - 640) / 2, 448 , 640, 0, 0, 160, 144);
				}
				//  - E[TCh
				if (messageStr != null) {
					StrImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					StrImgG.fillRect(0, 0, w, 32);
					StrImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					StrImgG.drawString(messageStr, w / 2 - 312, BASE_LINE);
					g.setFlipMode(Graphics.FLIP_ROTATE_LEFT);
					g.drawImage(StrImg, h - 32, 0, 0, 0, w, 32);
					messageStr = null;
				}
				break;
			default :
				if (Anti_Alias) {
					g.drawScaledImage(img, 0, (w - 640) / 2, 480 , 640, 0, 0, 240, 216);
				} else {
					g.drawScaledImage(img, 0, (w - 640) / 2, 480 , 640, 0, 0, 160, 144);
				}
				break;
		}
	}

	public void vrt_full(Graphics g, String messageStr, int fpsDisp, boolean Anti_Alias){
		g.setFlipMode(Graphics.FLIP_NONE);
		switch (fpsDisp) {
			case 0 :
				BaseImg2G.setColor(Graphics.getColorOfName(Graphics.BLACK));
				BaseImg2G.fillRect(0, 0, h, w);
				BaseImg2G.setFlipMode(Graphics.FLIP_NONE);
				if (Anti_Alias) {
					BaseImg2G.drawScaledImage(img, 0, 0, h, w, 0, 0, 240, 216);
				} else {
					BaseImg2G.drawScaledImage(img, 0, 0, h, w, 0, 0, 160, 144);
				}
				//  - ŉ[X^bN
				if (messageStr != null) {
					BaseImg2G.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00, 0xAA));
					BaseImg2G.fillRect(0, w-32, h, 32);
					BaseImg2G.setColor(Graphics.getColorOfName(Graphics.WHITE));
					BaseImg2G.drawString(messageStr, 8, w-32 + BASE_LINE);
					messageStr = null;
				}
				g.drawImage(BaseImg2, 0, 0);
				break;
			case 1 :
				if (Anti_Alias) {
					g.drawScaledImage(img, 0, 0, h, w -32, 0, 0, 240, 216);
				} else {
					g.drawScaledImage(img, 0, 0, h, w -32, 0, 0, 160, 144);
				}
				//  - ŉ[tB
				if (messageStr != null) {
					g.setColor(Graphics.getColorOfName(Graphics.BLACK));
					g.fillRect(0, w-32, h, 32);
					g.setColor(Graphics.getColorOfName(Graphics.WHITE));
					g.drawString(messageStr, 8, w-32 + BASE_LINE);
					messageStr = null;
				}
				break;
			case 2 :
				if (Anti_Alias) {
					g.drawScaledImage(img, 0, 0, h - 32, w, 0, 0, 240, 216);
				} else {
					g.drawScaledImage(img, 0, 0, h - 32, w, 0, 0, 160, 144);
				}
				//  - E[TCh
				if (messageStr != null) {
					StrImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					StrImgG.fillRect(0, 0, w, 32);
					StrImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					StrImgG.drawString(messageStr, 8, BASE_LINE);
					g.setFlipMode(Graphics.FLIP_ROTATE_LEFT);
					g.drawImage(StrImg, h - 32, 0, 0, 0, w, 32);
					messageStr = null;
				}
				break;
			default :
				if (Anti_Alias) {
					g.drawScaledImage(img, 0, 0, h, w, 0, 0, 240, 216);
				} else {
					g.drawScaledImage(img, 0, 0, h, w, 0, 0, 160, 144);
				}
				break;
		}
	}

	public void vrt_free(Graphics g, int pos_x, int pos_y, int x, int y, String messageStr, int fpsDisp, boolean Anti_Alias){
		g.setFlipMode(Graphics.FLIP_NONE);
		switch (fpsDisp) {
			case 0 :
				BaseImg2G.setColor(Graphics.getColorOfName(Graphics.BLACK));
				BaseImg2G.fillRect(0, 0, h, w);
				BaseImg2G.setFlipMode(Graphics.FLIP_NONE);
				if (Anti_Alias) {
					BaseImg2G.drawScaledImage(img, pos_x, pos_y, x, y, 0, 0, 240, 216);
				} else {
					BaseImg2G.drawScaledImage(img, pos_x, pos_y, x, y, 0, 0, 160, 144);
				}
				//  - ŉ[X^bN
				if (messageStr != null) {
					BaseImg2G.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00, 0xAA));
					BaseImg2G.fillRect(0, pos_y + y-32, h, 32);
					BaseImg2G.setColor(Graphics.getColorOfName(Graphics.WHITE));
					BaseImg2G.drawString(messageStr, 8, pos_y + y-32 + BASE_LINE);
					messageStr = null;
				}
				g.drawImage(BaseImg2, 0, 0);
				break;
			case 1 :
				if (Anti_Alias) {
					g.drawScaledImage(img, pos_x, pos_y, x, y-32, 0, 0, 240, 216);
				} else {
					g.drawScaledImage(img, pos_x, pos_y, x, y-32, 0, 0, 160, 144);
				}
				//  - ŉ[tB
				//Yɍ킹ăbZ[W\ʒuB
				if (messageStr != null) {
					g.setColor(Graphics.getColorOfName(Graphics.BLACK));
					g.fillRect(0, pos_y + y-32, h, 32);
					g.setColor(Graphics.getColorOfName(Graphics.WHITE));
					g.drawString(messageStr, pos_x + 8, pos_y + y-32 + BASE_LINE);
					messageStr = null;
				}
				break;
			case 2 :
				if (Anti_Alias) {
					g.drawScaledImage(img, pos_x, pos_y, x-32, y, 0, 0, 240, 216);
				} else {
					g.drawScaledImage(img, pos_x, pos_y, x-32, y, 0, 0, 160, 144);
				}
				//  - E[TCh
				if (messageStr != null) {
					StrImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					StrImgG.fillRect(0, 0, w, 32);
					StrImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					StrImgG.drawString(messageStr, w - pos_y - y + 8, BASE_LINE);
					g.setFlipMode(Graphics.FLIP_ROTATE_LEFT);
					g.drawImage(StrImg, pos_x + x - 32, 0, 0, 0, w, 32);
					messageStr = null;
				}
				break;
			default :
				if (Anti_Alias) {
					g.drawScaledImage(img, pos_x, pos_y, x, y, 0, 0, 240, 216);
				} else {
					g.drawScaledImage(img, pos_x, pos_y, x, y, 0, 0, 160, 144);
				}
				break;
		}

	}

	public void hrz(Graphics g, String messageStr, int fpsDisp){
		BaseImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
		BaseImgG.fillRect(0, 0, w, h);
		BaseImgG.setFlipMode(Graphics.FLIP_NONE);
		BaseImgG.drawScaledImage(img, (w - 320) / 2, (h - 320) / 2, 320, 288, 0, 0, 160, 144);
		switch (fpsDisp) {
			case 0 :
			case 1 :
				//  - ŉ[
				if (messageStr != null) {
					BaseImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					BaseImgG.fillRect(0, (h - 320) / 2 +288, w, 32);
					BaseImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					BaseImgG.drawString(messageStr, (w - 320) / 2 + 8, (h - 320) / 2 +288 + BASE_LINE);
					messageStr = null;
				}
				break;
			case 2 :
				//  - E[
				if (messageStr != null) {
					StrImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					StrImgG.fillRect(0, 0, h, 32);
					StrImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					StrImgG.drawString(messageStr, (h - 320) / 2 + 40, BASE_LINE);
					BaseImgG.setFlipMode(Graphics.FLIP_ROTATE_LEFT);
					BaseImgG.drawImage(StrImg, (w - 320) / 2 + 320, 0, 0, 0, h, 32);
					messageStr = null;
				}
				break;
			default :
				break;
		}
		g.setFlipMode(Graphics.FLIP_ROTATE_RIGHT);
		g.drawImage(BaseImg, 0, 0);
	}

	public void hrz_large(Graphics g, String messageStr, int fpsDisp, boolean Anti_Alias){
		BaseImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
		BaseImgG.fillRect(0, 0, w, h);
		BaseImgG.setFlipMode(Graphics.FLIP_NONE);
		switch (fpsDisp) {
			case 0 :
			case 1 :
				if (Anti_Alias) {
					BaseImgG.drawScaledImage(img, (w - 480) / 2, (h - 464) / 2, 480, 432, 0, 0, 240, 216);
				} else {
					BaseImgG.drawScaledImage(img, (w - 480) / 2, (h - 464) / 2, 480, 432, 0, 0, 160, 144);
				}
				//  - ŉ[
				if (messageStr != null) {
					BaseImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					BaseImgG.fillRect(0, (h - 464) / 2 + 432, w, 32);
					BaseImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					BaseImgG.drawString(messageStr, (w - 480) / 2 + 8, (h - 464) / 2 + 432 + BASE_LINE);
					messageStr = null;
				}
				break;
			case 2 :
				if (Anti_Alias) {
					BaseImgG.drawScaledImage(img, (w - 480) / 2, (h - 464) / 2, 448, 432, 0, 0, 240, 216);
				} else {
					BaseImgG.drawScaledImage(img, (w - 480) / 2, (h - 464) / 2, 448, 432, 0, 0, 160, 144);
				}
				//  - E[
				if (messageStr != null) {
					StrImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					StrImgG.fillRect(0, 0, h, 32);
					StrImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					StrImgG.drawString(messageStr, (h - 464) / 2 + 40, BASE_LINE);
					BaseImgG.setFlipMode(Graphics.FLIP_ROTATE_LEFT);
					BaseImgG.drawImage(StrImg, (w - 480) / 2 + 448, 0, 0, 0, h, 32);
					messageStr = null;
				}
				break;
			default :
				if (Anti_Alias) {
					BaseImgG.drawScaledImage(img, (w - 480) / 2, (h - 464) / 2, 480, 432, 0, 0, 240, 216);
				} else {
					BaseImgG.drawScaledImage(img, (w - 480) / 2, (h - 464) / 2, 480, 432, 0, 0, 160, 144);
				}
				break;
		}
		g.setFlipMode(Graphics.FLIP_ROTATE_RIGHT);
		g.drawImage(BaseImg, 0, 0);
	}

	public void hrz_wide(Graphics g, String messageStr, int fpsDisp, boolean Anti_Alias){
		BaseImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
		BaseImgG.fillRect(0, 0, w, h);
		BaseImgG.setFlipMode(Graphics.FLIP_NONE);
		switch (fpsDisp) {
			case 0 :
				if (Anti_Alias) {
					BaseImgG.drawScaledImage(img, (w - 640) / 2, (h - 480) / 2, 640, 480, 0, 0, 240, 216);
				} else {
					BaseImgG.drawScaledImage(img, (w - 640) / 2, (h - 480) / 2, 640, 480, 0, 0, 160, 144);
				}
				//  - ŉ[
				if (messageStr != null) {
					BaseImgG.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00, 0xAA));
					BaseImgG.fillRect(0, (h - 480) / 2 + 448, w, 32);
					BaseImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					BaseImgG.drawString(messageStr, (w - 640) / 2 + 8, (h - 480) / 2 + 448 + BASE_LINE);
					messageStr = null;
				}
				break;
			case 1 :
				if (Anti_Alias) {
					BaseImgG.drawScaledImage(img, (w - 640) / 2, (h - 480) / 2, 640, 448, 0, 0, 240, 216);
				} else {
					BaseImgG.drawScaledImage(img, (w - 640) / 2, (h - 480) / 2, 640, 448, 0, 0, 160, 144);
				}
				//  - ŉ[
				if (messageStr != null) {
					BaseImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					BaseImgG.fillRect(0, (h - 480) / 2 + 448, w, 32);
					BaseImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					BaseImgG.drawString(messageStr, (w - 640) / 2 + 8, (h - 480) / 2 + 448 + BASE_LINE);
					messageStr = null;
				}
				break;
			case 2 :
				if (Anti_Alias) {
					BaseImgG.drawScaledImage(img, (w - 640) / 2, (h - 480) / 2, 608, 480, 0, 0, 240, 216);
				} else {
					BaseImgG.drawScaledImage(img, (w - 640) / 2, (h - 480) / 2, 608, 480, 0, 0, 160, 144);
				}
				//  - E[
				if (messageStr != null) {
					StrImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					StrImgG.fillRect(0, 0, h, 32);
					StrImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					StrImgG.drawString(messageStr, 8, BASE_LINE);
					BaseImgG.setFlipMode(Graphics.FLIP_ROTATE_LEFT);
					BaseImgG.drawImage(StrImg, (w - 640) / 2 + 608, 0, 0, 0, h, 32);
					messageStr = null;
				}
				break;
			default :
				if (Anti_Alias) {
					BaseImgG.drawScaledImage(img, (w - 640) / 2, (h - 480) / 2, 640, 480, 0, 0, 240, 216);
				} else {
					BaseImgG.drawScaledImage(img, (w - 640) / 2, (h - 480) / 2, 640, 480, 0, 0, 160, 144);
				}
				break;
		}
		g.setFlipMode(Graphics.FLIP_ROTATE_RIGHT);
		g.drawImage(BaseImg, 0, 0);
	}

	public void hrz_full(Graphics g, String messageStr, int fpsDisp, boolean Anti_Alias){
		BaseImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
		BaseImgG.fillRect(0, 0, w, h);
		BaseImgG.setFlipMode(Graphics.FLIP_NONE);
		switch (fpsDisp) {
			case 0 :
				if (Anti_Alias) {
					BaseImgG.drawScaledImage(img, 0, 0, w, h, 0, 0, 240, 216);
				} else {
					BaseImgG.drawScaledImage(img, 0, 0, w, h, 0, 0, 160, 144);
				}
				//  - ŉ[
				if (messageStr != null) {
					BaseImgG.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00, 0xAA));
					BaseImgG.fillRect(0, 448, w, 32);
					BaseImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					BaseImgG.drawString(messageStr, 8, 448 + BASE_LINE);
					messageStr = null;
				}
				break;
			case 1 :
				if (Anti_Alias) {
					BaseImgG.drawScaledImage(img, 0, 0, w, h - 32, 0, 0, 240, 216);
				} else {
					BaseImgG.drawScaledImage(img, 0, 0, w, h - 32, 0, 0, 160, 144);
				}
				//  - ŉ[
				if (messageStr != null) {
					BaseImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					BaseImgG.fillRect(0, 448, w, 32);
					BaseImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					BaseImgG.drawString(messageStr, 8, 448 + BASE_LINE);
					messageStr = null;
				}
				break;
			case 2 :
				if (Anti_Alias) {
					BaseImgG.drawScaledImage(img, 0, 0, w - 32, h, 0, 0, 240, 216);
				} else {
					BaseImgG.drawScaledImage(img, 0, 0, w - 32, h, 0, 0, 160, 144);
				}
				//  - E[
				if (messageStr != null) {
					StrImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					StrImgG.fillRect(0, 0, h, 32);
					StrImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					StrImgG.drawString(messageStr, 8, BASE_LINE);
					BaseImgG.setFlipMode(Graphics.FLIP_ROTATE_LEFT);
					BaseImgG.drawImage(StrImg, w - 32, 0, 0, 0, h, 32);
					messageStr = null;
				}
				break;
			default :
				if (Anti_Alias) {
					BaseImgG.drawScaledImage(img, 0, 0, w, h, 0, 0, 240, 216);
				} else {
					BaseImgG.drawScaledImage(img, 0, 0, w, h, 0, 0, 160, 144);
				}
				break;
		}
		g.setFlipMode(Graphics.FLIP_ROTATE_RIGHT);
		g.drawImage(BaseImg, 0, 0);
	}

	public void hrz_free(Graphics g, int pos_x, int pos_y, int x, int y, String messageStr, int fpsDisp, boolean Anti_Alias){
		BaseImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
		BaseImgG.fillRect(0, 0, w, h);
		BaseImgG.setFlipMode(Graphics.FLIP_NONE);
		switch (fpsDisp) {
			case 0 :
				if (Anti_Alias) {
					BaseImgG.drawScaledImage(img, pos_x, pos_y, x, y, 0, 0, 240, 216);
				} else {
					BaseImgG.drawScaledImage(img, pos_x, pos_y, x, y, 0, 0, 160, 144);
				}
				//  - ŉ[X^bN
				if (messageStr != null) {
					BaseImgG.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00, 0xAA));
					BaseImgG.fillRect(0, pos_y + y-32, w, 32);
					BaseImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					BaseImgG.drawString(messageStr, pos_x + 8, pos_y + y-32 + BASE_LINE);
					messageStr = null;
				}
				break;
			case 1 :
				if (Anti_Alias) {
					BaseImgG.drawScaledImage(img, pos_x, pos_y, x, y-32, 0, 0, 240, 216);
				} else {
					BaseImgG.drawScaledImage(img, pos_x, pos_y, x, y-32, 0, 0, 160, 144);
				}
				//  - ŉ[tB
				//Yɍ킹ăbZ[W\ʒuB
				if (messageStr != null) {
					BaseImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					BaseImgG.fillRect(0, pos_y + y-32, w, 32);
					BaseImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					BaseImgG.drawString(messageStr, pos_x + 8, pos_y + y-32 + BASE_LINE);
					messageStr = null;
				}
				break;
			case 2 :
				if (Anti_Alias) {
					BaseImgG.drawScaledImage(img, pos_x, pos_y, x-32, y, 0, 0, 240, 216);
				} else {
					BaseImgG.drawScaledImage(img, pos_x, pos_y, x-32, y, 0, 0, 160, 144);
				}
				//  - E[TCh
				if (messageStr != null) {
					StrImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					StrImgG.fillRect(0, 0, h, 32);
					StrImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					StrImgG.drawString(messageStr, h - pos_y - y + 8, BASE_LINE);
					BaseImgG.setFlipMode(Graphics.FLIP_ROTATE_LEFT);
					BaseImgG.drawImage(StrImg, pos_x + x - 32, 0, 0, 0, h, 32);
					messageStr = null;
				}
				break;
			default :
				if (Anti_Alias) {
					BaseImgG.drawScaledImage(img, pos_x, pos_y, x, y, 0, 0, 240, 216);
				} else {
					BaseImgG.drawScaledImage(img, pos_x, pos_y, x, y, 0, 0, 160, 144);
				}
				break;
		}
		g.setFlipMode(Graphics.FLIP_ROTATE_RIGHT);
		g.drawImage(BaseImg, 0, 0);
	}

	public void drawString(Graphics g, int bgcolor, int fontcolor, String str, int x, int y){
		int width = Font.getDefaultFont().stringWidth(str);
		int height = Font.getDefaultFont().getHeight();
		Image img = Image.createImage(width, height);
		Graphics imgG = img.getGraphics();

		imgG.setFont(Font.getDefaultFont());
		imgG.setColor(bgcolor);
		imgG.fillRect(0, 0, width, height);
		imgG.setColor(fontcolor);
		imgG.drawString(str, 0, Font.getDefaultFont().getAscent());
		g.setFlipMode(Graphics.FLIP_ROTATE_RIGHT);
		g.drawImage(img, (h - y - Font.getDefaultFont().getAscent()), x);
	}

	public void drawString2(Graphics g, int bgcolor, int fontcolor, String str, int x, int y){
		int width = Font.getDefaultFont().stringWidth(str);
		int height = Font.getDefaultFont().getHeight();
		Image img = Image.createImage(width, height);
		Graphics imgG = img.getGraphics();

		imgG.setFont(Font.getDefaultFont());
		imgG.setColor(bgcolor);
		imgG.fillRect(0, 0, width, height);
		imgG.setColor(fontcolor);
		imgG.drawString(str, 0, Font.getDefaultFont().getAscent());
		g.setFlipMode(Graphics.FLIP_NONE);
		g.drawImage(img, x, y);
	}
}
